package Plugins;

# Before functions: they return something
@bfunctions = ('beforeAddUser', 'beforeDeleteUser', 'beforeChangeAttribute');

# After functions
@afunctions = ('afterAddUser', 'afterDeleteUser', 'afterChangeAttribute');

# Search functions
@sfunctions = ('bonusSearch');

# Get registered plugins list
open(CFG, "$config::etc_dir/plugins.conf") or die "$0: error opening $config::etc_dir/plugins.conf for reading ($!)\n";
chomp(@raw = <CFG>);
AOSICFG::write_ws_log('-=- Plugins: config=' . join(",", @raw)) if $config::aosi_debug_level > 3;
close(CFG);

sub dump_hash {
    my($hash, $dont_dump) = @_;
    my($out, $key, $val, $len);
    $out = '';

    foreach $key(keys %$hash){
        $val = $hash->{$key};
        Encode::_utf8_on($val);
        if(ref($val) eq 'ARRAY'){
            $val = '['.join(',',@$val).']';
        }
        if(ref($val) eq 'HASH'){
            $val = dump_hash($val);
        }
        $out .= "{" . $key." => ".$val."} ";

    }
    return $out;
}

$status_hash = undef;

# Check if plugin file exists
@plugins = ();
foreach $plugin (@raw) {
    chomp($plugin);
    $file = $config::plugins_dir . '/' . $plugin . '.pm';
    if (-e $file) {
        AOSICFG::write_ws_log('-=- Plugins: ' . $plugin . ' plugin file found at ' . $file . '!');
        push(@plugins, $plugin);
    }
    else {
        AOSICFG::write_ws_log('-=- Plugins: ' . $plugin . ' plugin file does not exist at ' . $file . '!');
    }
}

# Import plugins
foreach $plugin (@plugins) {
    #AOSICFG::write_ws_log('-=- Plugins: registered plugin=' . $plugin) if $config::aosi_debug_level > 3;

    # Taint hack
    $plugin =~ /(.*)/;
    $plugin      = $1;  # This is tainted now
    $eval_file   = $config::plugins_dir . '/' . $plugin . '.pm';
    $eval_module = 'Plugins::' . $plugin;
    eval('use ' . $eval_module);
	if ($@){
		AOSICFG::write_ws_log('eval error for '.$plugin.': '.$@);
	}
}

# Process before functions
Encode::_utf8_on($evalfunc_str);
Encode::_utf8_on($eval_sub);
foreach $func (@bfunctions) {
    $eval_sub = 'sub ' . $func . ' {';
    $eval_sub .= '  my($arg1, $arg2, $arg3, $arg4, $arg5, $arg6, $arg7) = @_;';
    $eval_sub .= '  my($code, $msg, $panic, $msg2, $msg3, $msg4);';
    $eval_sub .= '  $status_hash = undef;';
    $eval_sub .= '  AOSICFG::write_ws_log(\'|* Plugins::' . $func . '(in): \'.$arg1.\';\'.$arg2.\';\'.$arg3.\';\'.$arg4.\';\'.$arg5.\';\'.$arg6.\';\'.$arg7)';
    $eval_sub .= '      if $config::aosi_debug_level > 1;';

    foreach $plugin (@plugins) {
        $eval_str     = "\$test = defined(&Plugins::" . $plugin . "::" . $func . ") ? 1 : 0";
        $evalfunc_str = ' ($code, $msg, $panic, $msg2, $msg3, $msg4) = ';
        $evalfunc_str .= "&Plugins::" . $plugin . "::" . $func . "(\$status_hash, \$arg1, \$arg2, \$arg3, \$arg4, \$arg5, \$arg6, \$arg7);";
        $evalfunc_str .= ' $status_hash->{\'' . $plugin . '\'}->{\'before\'}->{\'code\'} = $code;';
        $evalfunc_str .= ' $status_hash->{\'' . $plugin . '\'}->{\'before\'}->{\'msg\'} = $msg;';
        $evalfunc_str .= ' $status_hash->{\'' . $plugin . '\'}->{\'before\'}->{\'panic\'} = $panic;';
        $evalfunc_str .= ' $status_hash->{\'' . $plugin . '\'}->{\'before\'}->{\'msg2\'} = $msg2;';
        $evalfunc_str .= ' $status_hash->{\'' . $plugin . '\'}->{\'before\'}->{\'msg3\'} = $msg3;';
        $evalfunc_str .= ' $status_hash->{\'' . $plugin . '\'}->{\'before\'}->{\'msg4\'} = $msg4;';
        eval($eval_str);
        $test_str     = $test > 0 ? 'yes' : 'NO!';
        AOSICFG::write_ws_log('-=- Plugins: exists func Plugins::' . $plugin . '::' . $func . '=' . $test_str . ';') if $config::aosi_debug_level > 3;

        if ($test) {
            $eval_sub .= "  $evalfunc_str";
        }
    }
    $eval_sub .= '  AOSICFG::write_ws_log(\'|* Plugins::' . $func . '(out): \'.dump_hash($status_hash)) if $config::aosi_debug_level > 1;';
    $eval_sub .= 'return $status_hash;';

    $eval_sub .= '}';
    eval($eval_sub);
    AOSICFG::write_ws_log('-=- Plugins: ' . $eval_sub) if $config::aosi_debug_level > 4;
}

# Process after funcions
foreach $func (@afunctions) {
    $eval_sub = 'sub ' . $func . ' {';
    $eval_sub .= '  my($arg1, $arg2, $arg3, $arg4, $arg5, $arg6, $arg7) = @_;';
    $eval_sub .= '  my($code, $msg, $panic, $msg2, $msg3, $msg4);';
    $eval_sub .= '  AOSICFG::write_ws_log(\'|* Plugins::' . $func . '(in): \'.$arg1.\';\'.$arg2.\';\'.$arg3.\';\'.$arg4.\';\'.$arg5.\';\'.$arg6.\';\'.$arg7)';
    $eval_sub .= '      if $config::aosi_debug_level > 1;';

    foreach $plugin (@plugins) {
        $eval_str     = "\$test = defined(&Plugins::" . $plugin . "::" . $func . ") ? 1 : 0;";
        $evalfunc_str = '($code, $msg, $panic, $msg2, $msg3, $msg4) = ';
        $evalfunc_str .= "&Plugins::" . $plugin . "::" . $func . "(\$status_hash, \$arg1, \$arg2, \$arg3, \$arg4, \$arg5, \$arg6, \$arg7);";
        $evalfunc_str .= ' $status_hash->{\'' . $plugin . '\'}->{\'after\'}->{\'code\'} = $code;';
        $evalfunc_str .= ' $status_hash->{\'' . $plugin . '\'}->{\'after\'}->{\'msg\'} = $msg;';
        $evalfunc_str .= ' $status_hash->{\'' . $plugin . '\'}->{\'after\'}->{\'panic\'} = $panic;';
        $evalfunc_str .= ' $status_hash->{\'' . $plugin . '\'}->{\'after\'}->{\'msg2\'} = $msg2;';
        $evalfunc_str .= ' $status_hash->{\'' . $plugin . '\'}->{\'after\'}->{\'msg3\'} = $msg3;';
        $evalfunc_str .= ' $status_hash->{\'' . $plugin . '\'}->{\'after\'}->{\'msg4\'} = $msg4;';
        eval($eval_str);
        $test_str     = $test > 0 ? 'yes' : 'NO!';
        AOSICFG::write_ws_log('-=- Plugins: exists func Plugins::' . $plugin . '::' . $func . '=' . $test_str . ';') if $config::aosi_debug_level > 3;

        if ($test) {
            $eval_sub .= "  $evalfunc_str";
        }
    }
    $eval_sub .= '  AOSICFG::write_ws_log(\'|* Plugins::' . $func . '(out): \'.dump_hash($status_hash)) if $config::aosi_debug_level > 1;';
    $eval_sub .= 'return $status_hash;';

    $eval_sub .= '}';
    eval($eval_sub);
    AOSICFG::write_ws_log('-=- Plugins: ' . $eval_sub) if $config::aosi_debug_level > 4;
}

# Process search functions
Encode::_utf8_on($evalfunc_str);
Encode::_utf8_on($eval_sub);
foreach $func (@sfunctions) {
    $eval_sub = 'sub ' . $func . ' {';
    $eval_sub .= '  my($arg1, $arg2, $arg3, $arg4, $arg5, $arg6, $arg7) = @_;';
    $eval_sub .= '  my($xml, $code, $msg);';
    $eval_sub .= '  AOSICFG::write_ws_log(\'|* Plugins::' . $func . ': in=\'.$arg1.\';\'.$arg2.\';\'.$arg3.\';\'.$arg4.\';\'.$arg5.\';\'.$arg6.\';\'.$arg7)';
    $eval_sub .= '      if $config::aosi_debug_level > 1;';

    foreach $plugin (@plugins) {
        $eval_str     = "\$test = defined(&Plugins::" . $plugin . "::" . $func . ") ? 1 : 0";
        $evalfunc_str = ' ($xml, $code, $msg) = ';
        $evalfunc_str .= "&Plugins::" . $plugin . "::" . $func . "(\$arg1, \$arg2, \$arg3, \$arg4, \$arg5, \$arg6, \$arg7);";
        $evalfunc_str .= ' $status_hash->{\'' . $plugin . '\'}->{\'search\'}->{\'xml\'}  = $xml;';
        $evalfunc_str .= ' $status_hash->{\'' . $plugin . '\'}->{\'search\'}->{\'code\'} = $code;';
        $evalfunc_str .= ' $status_hash->{\'' . $plugin . '\'}->{\'search\'}->{\'msg\'}  = $msg;';
        eval($eval_str);
        $test_str     = $test > 0 ? 'yes' : 'NO!';
        AOSICFG::write_ws_log('-=- Plugins: exists func Plugins::' . $plugin . '::' . $func . '=' . $test_str . ';') if $config::aosi_debug_level > 3;

        if ($test) {
            $eval_sub .= "  $evalfunc_str";
        }
    }
    $eval_sub .= '  AOSICFG::write_ws_log(\'|* Plugins::' . $func . '(out): \'.dump_hash($status_hash)) if $config::aosi_debug_level > 1;';
    $eval_sub .= 'return $status_hash;';

    $eval_sub .= '}';
    eval($eval_sub);
    AOSICFG::write_ws_log('-=- Plugins: ' . $eval_sub) if $config::aosi_debug_level > 4;
}


######################################################################
#
######################################################################
sub parse_ldap_xml {
    my($xml_in) = @_;
    my($this_fun, $xml, $code, $msg, $xml_ok);
    $this_fun = (caller(0))[3];

    $xml_ok = $xml_in;
    $xml_ok =~ s/^\s+//;
    if(substr($xml_ok, 0,5) ne '<?xml'){
        $xml_ok = '<?xml version="1.0"?>'.$xml_ok;
    }

    $xml = XML::Simple::XMLin($xml_ok, ForceArray => ['entry', 'status'], NormalizeSpace => 2);
    $code = $xml->{'status'}->[0]->{'code'};
    $msg = $xml->{'status'}->[0]->{'content'};

    return($code, $msg);
}

######################################################################
#
######################################################################
sub dump_entry {
    my ($ent) = @_;
    my ($dn, $ent_attrs, $att, $vals, $val, $out);

    $dn = $ent->{'dn'};
    $out .= '<entry dn="' . $dn . '">' . "\n";
    $ent_attrs = $ent->{'attrs'};
    foreach $attr (@$ent_attrs) {
        if(ref($attr) eq 'HASH'){
            $att  = $attr->{'att'};
            $vals = $attr->{'val'};
            if ($att) {
                $out .= '   <attribute ldapname="' . $att . '">' . "\n";
                foreach $val (@$vals) {
                    $out .= '       <value>' . $val . '</value>' . "\n";
                }
                $out .= '   </attribute>' . "\n";
            }
        }
    }
    $out .= '</entry>' . "\n";

    return $out;
}


1;
